"use strict";(self.webpackChunkBotBook=self.webpackChunkBotBook||[]).push([[795],{9674:(e,n,t)=>{t.r(n),t.d(n,{assets:()=>l,contentTitle:()=>s,default:()=>h,frontMatter:()=>i,metadata:()=>a,toc:()=>c});var r=t(4848),o=t(8453);const i={sidebar_position:0},s="General Bots Documentation",a={type:"mdx",permalink:"/",source:"@site/src/pages/index.md",title:"General Bots Documentation",description:"General Bots Logo",frontMatter:{sidebar_position:0},unlisted:!1},l={},c=[{value:"Introduction",id:"introduction",level:2},{value:"Table of Contents",id:"table-of-contents",level:2},{value:"Getting Started",id:"getting-started",level:2},{value:"Prerequisites",id:"prerequisites",level:3},{value:"Quick Start Guide",id:"quick-start-guide",level:3},{value:"Accessing Your Bot",id:"accessing-your-bot",level:3},{value:"Development Workflow",id:"development-workflow",level:2},{value:"1. Project Structure",id:"1-project-structure",level:3},{value:"2. Creating Custom Packages",id:"2-creating-custom-packages",level:3},{value:"3. API Reference",id:"3-api-reference",level:3},{value:"4. Testing",id:"4-testing",level:3},{value:"5. Deployment",id:"5-deployment",level:3},{value:"Advanced Topics",id:"advanced-topics",level:2},{value:"Community and Support",id:"community-and-support",level:2},{value:"Contributing",id:"contributing",level:2}];function d(e){const n={a:"a",code:"code",h1:"h1",h2:"h2",h3:"h3",header:"header",img:"img",li:"li",ol:"ol",p:"p",pre:"pre",strong:"strong",ul:"ul",...(0,o.R)(),...e.components};return(0,r.jsxs)(r.Fragment,{children:[(0,r.jsx)(n.header,{children:(0,r.jsx)(n.h1,{id:"general-bots-documentation",children:"General Bots Documentation"})}),"\n",(0,r.jsx)(n.p,{children:(0,r.jsx)(n.img,{src:"https://user-images.githubusercontent.com/65977273/94922431-949c3900-0490-11eb-800a-6b478d689f2a.png",alt:"General Bots Logo"})}),"\n",(0,r.jsx)(n.h2,{id:"introduction",children:"Introduction"}),"\n",(0,r.jsx)(n.p,{children:"Welcome to the comprehensive General Bots documentation. This guide serves as an essential reference for developers looking to harness the power and flexibility of the General Bots server. Our platform is designed with modularity in mind, allowing for easy customization and extension through various package types."}),"\n",(0,r.jsx)(n.p,{children:"In this documentation, we'll explore the architecture of the General Bots server, diving deep into its package-based structure. You'll learn how to leverage this modular approach for custom deployments, whether you're working with knowledge bases (.gbkb), themes (.gbtheme), or full-fledged applications (.gbapp)."}),"\n",(0,r.jsx)(n.h2,{id:"table-of-contents",children:"Table of Contents"}),"\n",(0,r.jsxs)(n.ul,{children:["\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/chapter-01-run-and-talk",children:"Chapter 01 - Run and Talk"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/chapter-02-the-package-based",children:"Chapter 02 - About Packages"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/chapter-03-gbkb-reference",children:"Chapter 03 - gbkb Reference"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/chapter-04-gbtheme-reference",children:"Chapter 04 - gbtheme Reference"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/chapter-05-gbdialog-reference",children:"Chapter 05 - gbdialog Reference"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/chapter-06-gbapp-reference",children:"Chapter 06 - gbapp Reference"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/chapter-07-gbot-reference",children:"Chapter 07 - gbot Reference"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/chapter-08-tooling",children:"Chapter 08 - Tooling"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/chapter-09-feature-matrix",children:"Chapter 09 - Feature-Matrix"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/chapter-10-contributing",children:"Chapter 10 - Contributing"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/apendix-i-database-model",children:"Apendix I - Database Model"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.a,{href:"docs/glossary",children:"Glossary"})}),"\n"]}),"\n",(0,r.jsx)(n.h2,{id:"getting-started",children:"Getting Started"}),"\n",(0,r.jsx)(n.h3,{id:"prerequisites",children:"Prerequisites"}),"\n",(0,r.jsx)(n.p,{children:"Before you embark on your General Bots journey, ensure you have the following tools installed:"}),"\n",(0,r.jsxs)(n.ul,{children:["\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.strong,{children:"Node.js (version 20 or later)"}),": General Bots leverages the latest features of Node.js to provide a robust and efficient runtime environment. Download it from ",(0,r.jsx)(n.a,{href:"https://nodejs.org/en/download/",children:"nodejs.org"}),"."]}),"\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.strong,{children:"Git (latest stable version)"}),": Essential for version control and collaborating on bot projects. Get it from ",(0,r.jsx)(n.a,{href:"https://git-scm.com/downloads",children:"git-scm.com"}),"."]}),"\n"]}),"\n",(0,r.jsx)(n.h3,{id:"quick-start-guide",children:"Quick Start Guide"}),"\n",(0,r.jsx)(n.p,{children:"Follow these steps to get your General Bots server up and running:"}),"\n",(0,r.jsxs)(n.ol,{children:["\n",(0,r.jsxs)(n.li,{children:["\n",(0,r.jsx)(n.p,{children:"Clone the repository:"}),"\n",(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{className:"language-bash",children:"git clone https://github.com/GeneralBots/BotServer\n"})}),"\n",(0,r.jsx)(n.p,{children:"This command creates a local copy of the General Bots server repository on your machine."}),"\n"]}),"\n",(0,r.jsxs)(n.li,{children:["\n",(0,r.jsx)(n.p,{children:"Navigate to the project directory:"}),"\n",(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{className:"language-bash",children:"cd BotServer\n"})}),"\n",(0,r.jsx)(n.p,{children:"This changes your current directory to the newly cloned BotServer folder."}),"\n"]}),"\n",(0,r.jsxs)(n.li,{children:["\n",(0,r.jsx)(n.p,{children:"Install dependencies and start the server:"}),"\n",(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{className:"language-bash",children:"npm install\nnpm run start\n"})}),"\n",(0,r.jsxs)(n.p,{children:["The ",(0,r.jsx)(n.code,{children:"npm install"})," command installs all necessary dependencies for the project. ",(0,r.jsx)(n.code,{children:"npm run start"})," builds your bot server locally and serves it through a development server."]}),"\n"]}),"\n"]}),"\n",(0,r.jsx)(n.h3,{id:"accessing-your-bot",children:"Accessing Your Bot"}),"\n",(0,r.jsxs)(n.p,{children:["Once the server is running, you can access your bot at ",(0,r.jsx)(n.code,{children:"http://localhost:4242/"}),". This local server allows you to interact with your bot and test its functionality in real-time."]}),"\n",(0,r.jsx)(n.p,{children:"To publish bot packages and initiate a conversation with the bot, use the command:"}),"\n",(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{children:"/publish\n"})}),"\n",(0,r.jsx)(n.p,{children:"This command prepares your bot packages for use and allows you to start interacting with your bot immediately."}),"\n",(0,r.jsx)(n.h2,{id:"development-workflow",children:"Development Workflow"}),"\n",(0,r.jsx)(n.h3,{id:"1-project-structure",children:"1. Project Structure"}),"\n",(0,r.jsx)(n.p,{children:"The General Bots server follows a modular architecture designed for flexibility and scalability. Here's an overview of the main directories:"}),"\n",(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{children:"BotServer/\n\u251c\u2500\u2500 packages/\n\u2502   \u251c\u2500\u2500 core.gbapp/         # Core bot functionality\n\u2502   \u251c\u2500\u2500 kb.gbapp/           # Knowledge base packages\n\u251c\u2500\u2500 src /             # Main entry point\n\u2514\u2500\u2500 package.json      # Project configuration\n"})}),"\n",(0,r.jsx)(n.p,{children:"This structure allows for easy navigation and management of different aspects of your bot project."}),"\n",(0,r.jsx)(n.h3,{id:"2-creating-custom-packages",children:"2. Creating Custom Packages"}),"\n",(0,r.jsx)(n.p,{children:"One of the strengths of General Bots is its extensibility. You can create custom packages to enhance your bot's capabilities:"}),"\n",(0,r.jsxs)(n.ul,{children:["\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.strong,{children:".gbkb (Knowledge Base packages)"}),": Store and manage your bot's knowledge and responses."]}),"\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.strong,{children:".gbtheme (Theme packages)"}),": Customize the visual appearance of your bot interface."]}),"\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.strong,{children:".gbapp (Application packages)"}),": Add new features and functionalities to your bot."]}),"\n"]}),"\n",(0,r.jsx)(n.p,{children:"Each package type has its own structure and purpose, which we'll explore in depth in their respective chapters."}),"\n",(0,r.jsx)(n.h3,{id:"3-api-reference",children:"3. API Reference"}),"\n",(0,r.jsx)(n.p,{children:"For detailed information on working with each package type, refer to the following chapters:"}),"\n",(0,r.jsxs)(n.ul,{children:["\n",(0,r.jsx)(n.li,{children:"Chapter 3: gbkb Reference - Learn how to create and manage knowledge bases"}),"\n",(0,r.jsx)(n.li,{children:"Chapter 4: gbtheme Reference - Discover the theming capabilities of General Bots"}),"\n",(0,r.jsx)(n.li,{children:"Chapter 5: gbdialog Reference - Master the art of creating dynamic conversations"}),"\n",(0,r.jsx)(n.li,{children:"Chapter 6: gbapp Reference - Explore the full potential of bot applications"}),"\n",(0,r.jsx)(n.li,{children:"Chapter 7: gbot Reference - Understand the core functionalities of your bot"}),"\n"]}),"\n",(0,r.jsx)(n.p,{children:"These chapters provide comprehensive API documentation, usage examples, and best practices for each package type."}),"\n",(0,r.jsx)(n.h3,{id:"4-testing",children:"4. Testing"}),"\n",(0,r.jsx)(n.p,{children:"We strongly encourage writing unit tests for your custom packages to ensure reliability and ease of maintenance. To run tests, use the following command:"}),"\n",(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{className:"language-bash",children:"npm run test\n"})}),"\n",(0,r.jsxs)(n.p,{children:["This command executes the test suites located in the ",(0,r.jsx)(n.code,{children:"tests/"})," directory, allowing you to verify the functionality of your bot components."]}),"\n",(0,r.jsx)(n.h3,{id:"5-deployment",children:"5. Deployment"}),"\n",(0,r.jsxs)(n.p,{children:["When you're ready to deploy your bot to a production environment, the ",(0,r.jsx)(n.code,{children:"npm run build"})," command creates an optimized production build of your bot server."]}),"\n",(0,r.jsx)(n.h2,{id:"advanced-topics",children:"Advanced Topics"}),"\n",(0,r.jsx)(n.p,{children:"As you become more familiar with General Bots, you may want to explore these advanced topics:"}),"\n",(0,r.jsxs)(n.ul,{children:["\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.strong,{children:"Scalability"}),": Chapter 9 - Services delves into horizontal scaling options, allowing your bot to handle increased load and user interactions efficiently."]}),"\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.strong,{children:"Performance Tuning"}),": Chapter 8 - Tooling offers insights and techniques for optimizing your bot's performance, ensuring smooth operation even under demanding conditions."]}),"\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.strong,{children:"Security Best Practices"}),": Chapter 10 - Contributing outlines important security guidelines to keep your bot and its data protected."]}),"\n"]}),"\n",(0,r.jsx)(n.p,{children:"These advanced topics will help you take your General Bots implementation to the next level, creating robust, scalable, and secure bot solutions."}),"\n",(0,r.jsx)(n.h2,{id:"community-and-support",children:"Community and Support"}),"\n",(0,r.jsx)(n.p,{children:"Join our vibrant community of bot developers:"}),"\n",(0,r.jsxs)(n.ul,{children:["\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.strong,{children:"GitHub Issues"}),": For bug reports and feature requests, visit our ",(0,r.jsx)(n.a,{href:"https://github.com/GeneralBots/BotServer/issues",children:"issue tracker"}),". Here, you can report problems, suggest improvements, or even contribute code fixes."]}),"\n"]}),"\n",(0,r.jsx)(n.h2,{id:"contributing",children:"Contributing"}),"\n",(0,r.jsxs)(n.p,{children:["We welcome contributions from developers of all skill levels! Whether you're fixing a bug, adding a feature, or improving documentation, your input is valuable. Please read our ",(0,r.jsx)(n.a,{href:"docs/chapter-10-contributing",children:"Contributing Guide"})," for details on our code of conduct and the process for submitting pull requests."]}),"\n",(0,r.jsx)(n.p,{children:"Remember, the General Bots platform is designed to be flexible and extensible. We encourage you to explore its capabilities, experiment with new ideas, and contribute to making it even better. Your creativity and expertise can help shape the future of conversational AI!"})]})}function h(e={}){const{wrapper:n}={...(0,o.R)(),...e.components};return n?(0,r.jsx)(n,{...e,children:(0,r.jsx)(d,{...e})}):d(e)}},8453:(e,n,t)=>{t.d(n,{R:()=>s,x:()=>a});var r=t(6540);const o={},i=r.createContext(o);function s(e){const n=r.useContext(i);return r.useMemo((function(){return"function"==typeof e?e(n):{...n,...e}}),[n,e])}function a(e){let n;return n=e.disableParentContext?"function"==typeof e.components?e.components(o):e.components||o:s(e.components),r.createElement(i.Provider,{value:n},e.children)}}}]);